<-- THIS FILE WILL NOT WORK AS IT IS A DIRECT COPY FROM AN EXTERNALL APP -->
<template>
  <div
    class="fixed z-[1900] w-full top-0 left-0 flex items-center h-18 px-4  xl:px-18 py-3 bg-blue-deep border-b-[3px] border-primary"
  >
    <button
      class="relative w-8 h-8 mr-5 text-2xl z-10 block focus:outline-none  xl:hidden"
      aria-label="Mobile menu"
      type="button"
    >
      <font-awesome-icon
        class="text-white-default cursor-pointer absolute top-2/4 left-2/4 transform -translate-x-2/4 -translate-y-2/4 transition duration-500 ease-in-out"
        :class="[isMobileOpen ? 'opacity-0' : 'opacity-100']"
        :icon="['fal', 'bars']"
        fixed-width
        @click="toggleMobile()"
      />
      <font-awesome-icon
        class="text-primary cursor-pointer absolute top-2/4 left-2/4 transform -translate-x-2/4 -translate-y-2/4 transition duration-500 ease-in-out"
        :class="[isMobileOpen ? 'opacity-100' : 'opacity-0']"
        :icon="['fal', 'times']"
        fixed-width
        @click="toggleMobile()"
      />
    </button>

    <nuxt-link to="/" class=" xl:hidden" @click.native="closeMenu">
      <Logo
        mini
        class="transition-all duration-300"
        :class="[isScrolled ? 'w-3 opacity-100' : 'opacity-0 w-0 delay-300']"
      />
      <Logo
        class="transition-all duration-1000"
        :class="[isScrolled ? 'opacity-0 w-0' : 'opacity-100 w-28 delay-500']"
      />
    </nuxt-link>

    <nuxt-link to="/" class="hidden  xl:block">
      <Logo class="w-36" />
    </nuxt-link>

    <nuxt-link
      to="/jobs"
      class=" xl:hidden ml-auto overflow-hidden transition-all duration-300 delay-200"
      :class="[isScrolled ? 'w-60 opacity-100' : 'w-0 opacity-0']"
    >
      <AppButton type="primary" class="w-full">
        Jetzt bewerben
      </AppButton>
    </nuxt-link>

    <!-- Desktop Menu -->
    <nav class="hidden xl:block xl:w-full">
      <ul class="flex items-center justify-end">
        <li
          v-for="nav in navigation"
          :key="nav.Title"
          class="truncate mr-6 cursor-pointer text-white-default hover:text-primary transition-colors duration-200"
        >
          <nuxt-link
            v-if="nav.link_to.includes('#')"
            :to="{ path: '/', hash: nav.link_to }"
          >
            {{ nav.Title }}
          </nuxt-link>
          <nuxt-link v-else :to="nav.link_to">
            {{ nav.Title }}
          </nuxt-link>
        </li>

        <li class="mr-6 w-full max-w-xxs">
          <a href="https://up2parts.com" target="_blank">
            <AppButton :gradient="true" :dark="true">
              Zu up2parts.com
            </AppButton>
          </a>
        </li>
        <li class="w-full max-w-xxs">
          <nuxt-link to="/jobs">
            <AppButton type="primary" class="w-full">
              Jetzt bewerben
            </AppButton>
          </nuxt-link>
        </li>
      </ul>
    </nav>

    <!-- Mobile Menu -->
    <nav
      class="w-full bg-blue-deep absolute top-18 left-0 px-4 overflow-hidden transition-all duration-500 ease-in-out  xl:hidden"
      :class="[
        { 'visibleMenu pt-4 pb-8': isMobileOpen },
        { 'h-0': !isMobileOpen }
      ]"
    >
      <ul class="flex flex-col items-center">
        <li
          v-for="nav in navigation"
          :key="nav.Title + '-mobile'"
          class="mb-4 cursor-pointer text-white-default hover:text-primary transition-colors duration-200"
          @click="closeMenu"
        >
          <nuxt-link
            v-if="nav.link_to.includes('#')"
            :to="{ path: '/', hash: nav.link_to }"
          >
            {{ nav.Title }}
          </nuxt-link>
          <nuxt-link v-else :to="nav.link_to">
            {{ nav.Title }}
          </nuxt-link>
        </li>

        <li class="mb-5 z-10 w-full max-w-xxs">
          <a href="https://up2parts.com" target="_blank">
            <AppButton :gradient="true" :dark="true">
              Zu up2parts.com
            </AppButton>
          </a>
        </li>
        <li v-if="!isScrolled" class="w-full max-w-xxs">
          <nuxt-link to="/jobs">
            <AppButton type="primary" class="w-full">
              Jetzt bewerben
            </AppButton>
          </nuxt-link>
        </li>
      </ul>
    </nav>
  </div>
</template>

<script lang="ts">
import {
  defineComponent,
  ref,
  onMounted,
  onBeforeUnmount,
  Ref,
  useContext
} from "@nuxtjs/composition-api";
import Logo from "@/components/Logo.vue";
import AppButton from "@/components/base/AppButton.vue";
import debounce from "lodash.debounce";
import navQuery from "~/queries/navigation.gql";
let debounced: any = null;

export default defineComponent({
  components: {
    Logo,
    AppButton
  },
  setup() {
    const { app } = useContext();
    const isMobileOpen: Ref<boolean> = ref(false);
    const isScrolled: Ref<boolean> = ref(false);

    const toggleMobile = () => {
      isMobileOpen.value = !isMobileOpen.value;
    };

    const closeMenu = () => {
      isMobileOpen.value = false;
    };

    const navigation = app.$fetchQueryData(navQuery, { path: "navigation" });
    onMounted(() => {
      if (window) {
        debounced = debounce(() => {
          closeMenu();
          const offset = window.pageYOffset;
          if (offset > 80) {
            isScrolled.value = true;
          } else {
            isScrolled.value = false;
          }
        }, 100);
        window.addEventListener("scroll", debounced);
      }
    });

    onBeforeUnmount(() => {
      if (window) {
        window.removeEventListener("scroll", debounced);
      }
    });

    return { navigation, isScrolled, isMobileOpen, toggleMobile, closeMenu };
  }
});
</script>

<style lang="scss">
.visibleMenu {
  height: calc(100vh - 72px);
}
</style>
